;
; Carka_Tiny.asm
;
; Created: 17.08.2017 12:47:27
; Author : Miroslav Cina
;


; Replace with your application code
start:
	sbi		DDRA,0x05			;PA5 to output
	sbi		DDRA,0x00			;PA0 to output (MOSI / DIN)
	sbi		DDRA,0x01			;PA1 to output (CLK  / CLK)
	sbi		DDRA,0x02			;PA2 to output (CS   / LE)
;-------------------------------------------------------


	ldi		R18,0x05
loop1:
	sbi		PORTA,0x05
	rcall	delay1
	cbi		PORTA,0x05
	rcall	delay1
	dec		r18
	brne	loop1

	sbi		PORTA,0x05		;I'm alive LED on

loop2:
;Step 01
	ldi		r26,0xAA
	ldi		r27,0x00
	rcall	send_data
	rcall	delay1

;Step 02
	ldi		r26,0x55
	ldi		r27,0x00
	rcall	send_data
	rcall	delay1

;Step 03
	ldi		r26,0x2A
	ldi		r27,0x80
	rcall	send_data
	rcall	delay1

;Step 04
	ldi		r26,0x15
	ldi		r27,0x40
	rcall	send_data
	rcall	delay1

;Step 05
	ldi		r26,0x0A
	ldi		r27,0xA0
	rcall	send_data
	rcall	delay1

;Step 06
	ldi		r26,0x05
	ldi		r27,0x50
	rcall	send_data
	rcall	delay1

;Step 07
	ldi		r26,0x02
	ldi		r27,0xA8
	rcall	send_data
	rcall	delay1

;Step 08
	ldi		r26,0x01
	ldi		r27,0x54
	rcall	send_data
	rcall	delay1

;Step 09
	ldi		r26,0x00
	ldi		r27,0xAA
	rcall	send_data
	rcall	delay1

;Step 10
	ldi		r26,0x00
	ldi		r27,0x55
	rcall	send_data
	rcall	delay1

;Step 11
	ldi		r26,0x80
	ldi		r27,0x2A
	rcall	send_data
	rcall	delay1

;Step 12
	ldi		r26,0x40
	ldi		r27,0x15
	rcall	send_data
	rcall	delay1

;Step 13
	ldi		r26,0xA0
	ldi		r27,0x0A
	rcall	send_data
	rcall	delay1

;Step 14
	ldi		r26,0x50
	ldi		r27,0x05
	rcall	send_data
	rcall	delay1

;Step 15
	ldi		r26,0xA8
	ldi		r27,0x02
	rcall	send_data
	rcall	delay1

;Step 16
	ldi		r26,0x54
	ldi		r27,0x01
	rcall	send_data
	rcall	delay1

	rjmp	loop2
;-------------------------------------------------------
;-------------------------------------------------------
;MAX6969 communication routines
;-------------------------------------------------------
;-------------------------------------------------------
send_data:
	cbi		PORTA,0x02		;LE = 0

	mov		r19, r26
	rcall	send_byte

	mov		r19, r27
	rcall	send_byte

	sbi		PORTA,0x02		;LE = 1
	nop
	cbi		PORTA,0x02		;LE = 0
	ret
;-------------------------------------------------------
send_byte:
	cbi		PORTA,0x01		;CLK = 0

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x07
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x06
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x05
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x04
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x03
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x02
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x01
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	cbi		PORTA,0x00		;DIN = 0
	sbrc	R19,0x00
	sbi		PORTA,0x00		;DIN = 1
	rcall	send_bit

	ret
;-------------------------------------------------------
send_bit:
	sbi		PORTA,0x01		;CLK = 1
	nop
	cbi		PORTA,0x01		;CLK = 0
	ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
delay1:
	ldi		R17,255
d_loop2:
	ldi		R16,255
d_loop1:
	dec		R16
	brne	d_loop1
	dec		r17
	brne	d_loop2
	ret
;-------------------------------------------------------
delay2:
	rcall	delay1
	rcall	delay1
	rcall	delay1
	ret
;-------------------------------------------------------
;-------------------------------------------------------
delay3:
	ldi		R18,002
d_loop3b:
	ldi		R17,255
d_loop2b:
	ldi		R16,255
d_loop1b:
	dec		R16
	brne	d_loop1b
	dec		r17
	brne	d_loop2b
	dec		r18
	brne	d_loop3b
	ret
;-------------------------------------------------------
